/*
    Rad sa memorijom i listama relacija i funkcija.
*/

#include <string.h>
#include <stdlib.h>
#include "main.h"

/* ---------------------------------------------------------------------- */

void *alloc_mem (size_t size)
{
    void *p;
    
    p = malloc( size );
    if (!p)
    {
        _poruka( 10 );
        exit( 0 );
    }
    
    return p;
}

/* ---------------------------------------------------------------------- */
/* Ove f-je se koriste u drvo.c pa su zato i napisane. Inace treba koristiti
    alloc_mem () */

struct cvor *_daj_cvor (void)
{
    struct cvor *p;
    
    p = alloc_mem (sizeof (struct cvor));
    if( p ) memset( p, 0, sizeof( struct cvor ) );
    return p;    
}

void _oslobodi_cvor (struct cvor *p)
{
    free( p );
}

void _oslobodi_drvo (struct cvor *p)
{
    if( p == NULL ) return;
    _oslobodi_drvo( p->levi );
    _oslobodi_drvo( p->desni );
    free( p );
}

/* ---------------------------------------------------------------------- */
/* Tabela iskaznih slova */


static table_t *iskazna_slova = NULL;
static int broj_iskaznih_slova = 0;

int _kako_je_kodirano( char *name )
{
    int i = 0, found = 0;
    table_t *p = NULL, *q = NULL;
    
    for( p=iskazna_slova; p && (!found); p = p->next, i++) {
        found = (strcmp (name, p->name) == 0);
    }
        
    if( found ) return( i-1 );      /* i je polozaj u tabeli */

    q = alloc_mem( sizeof (table_t) );
    q->name = alloc_mem( MAX_SLOVA+1 );
    strcpy( q->name, name );
    q->next = NULL ;

    if( iskazna_slova != NULL ) {
     for( p=iskazna_slova; p->next; p = p->next, i++)
     p->next = q ;
    }
    else iskazna_slova = q;
    broj_iskaznih_slova ++;
    return( broj_iskaznih_slova-1 );
}

/* ---------------------------------------------------------------------- */

void _oslobodi_tabelu_is ( void )
{
    table_t *p;
    
    while( iskazna_slova ) {
        p=iskazna_slova->next;
        free( iskazna_slova -> name );
        iskazna_slova = p;
    }
}

